program icqx2001;
{$R *.res}
{$R maindlg.res}

uses
  Windows, Messages, Crk_Utils, ShellApi, ShlObj,ActiveX;

const

  DLG_MAIN = 'MAINDLG';
  IDC_ED_PATH = 500;
  IDC_ED_COUNT = 520;
  IDC_ED_BEGIN = 530;
  IDC_BTN_PATH = 510;
  IDC_BTN_APPLY = 1001;
  IDC_BTN_ABOUT = 1002;
  IDC_BTN_EXIT = 1003;
  IDC_CBX_DESK = 2000;
  IDC_CBX_PROG = 2001;
  IDC_GP_PATH = 501;
  IDC_GP_COUNT = 521;
  IDC_GP_BEGIN = 531;
  IDC_GP_ACTION = 1000;

  Slash='\';

var
  AIcon, hMain: THandle;
  Path:string;
  iCount,iBegin:int;
  isDeskLink,isProgLink:boolean;

procedure End_Work(AWnd: HWND);
begin
  EndDialog(AWnd, 0);
  Halt;
end;

procedure UpdateEnabled;
var
  s: string;
  b: boolean;
begin
  s := GetWndText(GetDlgItem(hMain, IDC_ED_PATH));
  b := FileExists(Pchar(s));
  b := b and (length(GetWndText(GetDlgItem(hMain, IDC_ED_COUNT))) > 0)
         and (length(GetWndText(GetDlgItem(hMain, IDC_ED_BEGIN))) > 0);
  EnableWindow(GetDlgItem(hMain, IDC_BTN_APPLY), b);
end;

type
  TMapData = record
    FileHandle,
    MapHandle: THandle;
    Pointer: pointer;
  end;

procedure CloseMapFile(var MapData: TMapData);
begin
  with mapdata do
  begin
    if Pointer <> nil then
      UnmapViewOfFile(Pointer);
    if MapHandle <> 0 then
      CloseHandle(MapHandle);
    if FileHandle <> 0 then
      CloseHandle(FileHandle);
  end;
  fillchar(mapdata, sizeof(Mapdata), 0);
end;

function OpenMapFile(FName: string; var MapData: TMapData): boolean;
begin
  fillChar(MapData, sizeof(Mapdata), 0);
  result := false;
  MapData.FileHandle := CreateFile(Pchar(Fname), GENERIC_READ, FILE_SHARE_READ,
    nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if (MapData.FileHandle = INVALID_HANDLE_VALUE) and not Error then
    exit;
  MapData.MapHandle := CreateFileMapping(MapData.FileHandle, nil, PAGE_READONLY,
    0, 0, nil);
  if MapData.MapHandle = 0 then
  begin
    CloseMapFile(MapData);
    exit;
  end;
  MapData.Pointer := MapViewOfFile(MapData.MapHandle, FILE_MAP_READ, 0, 0, 0);
  if MapData.Pointer = nil then
    CloseMapFile(MapData)
  else
    result := true;
end;

procedure DlgToVars;
var
  b:LongBool;
begin
  Path:=GetWndText(GetDlgItem(hmain, IDC_ED_PATH));
  icount:=Abs(GetDlgItemInt(hMain,IDC_ED_COUNT,b,true));
  iBegin:=Abs(GetDlgItemInt(hMain,IDC_ED_BEGIN,b,true));
  isDeskLink:=IsDlgButtonChecked(hmain,IDC_CBX_DESK)=BST_CHECKED;
  isProgLink:=IsDlgButtonChecked(hmain,IDC_CBX_PROG)=BST_CHECKED;
end;

function ReplaceNum(s:string;i:int):string;
begin
  result:=s;
  s:=IntToStr(i);
  i:=length(s);
  delete(result,length(result)-i+1,i);
  result:=result+s;
end;

procedure CreateLink(FileName: string);
var
  IObject: IUnknown;
  SLink: IShellLink;
  PFile: IPersistFile;
  path:array [0..MAX_PATH-1] of WideChar;
  ws:WideString;

  function GetSpecFolderPath(wPath:PWideChar;nFolder:integer):boolean;
  var
    PIDL:PItemIDList;
  begin
    result:=(SHGetSpecialFolderLocation(hMain,nFolder,pidl)=NOERROR ) and
      SHGetPathFromIDListW(Pidl,wPAth);
  end;

begin
  CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER or
    CLSCTX_LOCAL_SERVER, IUnknown, IObject);
  SLink := IObject as IShellLink;
  PFile := IObject as IPersistFile;
  with SLink do begin
    SetDescription('ICQ clone created by ICQX');
    SetWorkingDirectory(Pchar(ExtractFilePath(FileName)));
    SetPath(PChar(FileName));
    SetIconLocation(pchar(FileName),0);
  end;
  Filename:=ExtractFileName(Filename);
  Filename:=Slash+changefileext(FileName,'.lnk');
  ws:=FileName;
  if isDeskLink then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_DESKTOP,false);
    if GetSpecFolderPath(@path[0],CSIDL_DESKTOP) then
      PFile.Save(pWideChar(Path+ws), FALSE);
  end;
  if isProgLink then
  begin
//    SHGetSpecialFolderPathW(hMain,@path[0],CSIDL_PROGRAMS,false);
    if GetSpecFolderPath(@path[0],CSIDL_PROGRAMS) then
      PFile.Save(pWideChar(path+'\ICQ'+ws), FALSE);
  end;
end;


procedure Apply;
var
  i,j:int;
  s,r:string;
  iMutex,iOwner:dword;
  p:Pchar;
const
  sMutex='ICQ Mutex';
  sOwner='LastOwner';
begin
  DlgToVars;
  if not FileExists(Pchar(path)) then exit;
  p:=sMutex;
  iMutex:=FindDataInFile(Path,p,Length(sMutex));
  if iMutex=0 then
  begin
    ShowMessage(hMain,'Can''t find  Mutex in icq.exe');
    exit;
  end;
  p:=sOwner;
  iOwner:=FindDataInFile(Path,p,Length(sOwner));
  if iOwner=0 then
  begin
    ShowMessage(hMain,'Can''t find  LastOwner in icq.exe');
    exit;
  end;
  try
    for i:=0 to iCount-1 do
    begin
      s:=ChangeFileExt(path,'');
      j:=i+iBegin;
      s:=s+inttostr(j)+'.exe';
      if not CopyFile(Pchar(Path),pchar(s),false) then
      begin
        ShowMessage(hMain,'Can''t copy icq.exe to '+ExtractFileName(s));
        exit;
      end;
      r:=ReplaceNum(sMutex,j);
      p:=Pchar(r);
      WriteDataToFile(S,iMutex,p,length(r));
      r:=ReplaceNum(sOwner,j);
      p:=Pchar(r);
      WriteDataToFile(S,iOwner,p,length(r));
      CreateLink(s);
    end;
  finally
  end;  
  ShowMessage(hMain,'All copy created.');
end;

function FindICQPath:string;
const
  ICQRegRoot='Software\Mirabilis\ICQ\DefaultPrefs';
  Slash='\';
begin
  result:=RegGetString(ICQRegRoot,'ICQPath','');
  if result='' then exit;
  if result[length(result)]<>Slash then result:=result+Slash;
  result:=result+'icq.exe';
  SetDlgItemText(hMain,IDC_ED_PATH,Pchar(result));
end;

function DlgProc(hWin, uMsg, wParam, lParam: Integer): Integer; stdcall;
var
  s: string;
begin
  Result := 0;
  case uMsg of
    WM_COMMAND: case LOWORD(wParam) of
        IDC_BTN_EXIT: End_Work(HWin);
        IDC_ED_PATH,
        IDC_ED_COUNT,
        IDC_ED_BEGIN: if HIWORD(wParam) = EN_CHANGE then
            UpdateEnabled;
        IDC_BTN_PATH: if HIWORD(wParam) = BN_CLICKED then
          begin
            s := 'icq.exe';
            if SelectExeFile(s) then
              SetDlgItemText(hWin, IDC_ED_PATH, Pchar(s));
          end;
        IDC_BTN_ABOUT: if HIWORD(wParam) = BN_CLICKED then
            ShellAbout(hMain, 'ICQX v1.01 for ICQ 2001b',
              'Copyright  Tir Na Nog'#13#10'http://tirna.narod.ru', AIcon);
        IDC_BTN_APPLY: if HIWORD(wParam) = BN_CLICKED then
            Apply;
      end;
    WM_INITDIALOG:
      begin
        hMAin := hWin;
        AIcon := LoadIcon(hInstance, 'MAINICON');
        SendMessage(hWin, WM_SETICON, ICON_SMALL, AIcon);
        SendMessage(hWin, WM_SETICON, ICON_BIG, AIcon);
        FindICQPath;
        SetDlgItemInt(hMain, IDC_ED_COUNT, 1,false);
        SetDlgItemInt(hMain, IDC_ED_BEGIN, 1,false);
        CheckDlgButton(hWin, IDC_CBX_DESK, BST_CHECKED);
        CheckDlgButton(hWin, IDC_CBX_PROG, BST_CHECKED);
      end;
    WM_DESTROY,
      WM_CLOSE: End_Work(hWin);
  end;
end;


begin
  CoInitialize(nil);
  try
    DialogBoxParam(HINSTANCE, PChar(DLG_MAIN), 0, @DlgProc, 0)
  finally
    CoUninitialize;
  end;
end.
